-----------------------------------------------------------------
-- |
-- Module      : Compiler.Manager
-- Copyright   : (c) Babel Group 2004
-- License     : GPL
--
-- Maintainer  : egallego@babel.ls.fi.upm.es
-- Stability   : very experimental
-- Portability : portable
--
-- Some utilities for compilation management.
-- 
-----------------------------------------------------------------
module Compiler.Manager (
			 CManager(compile),
			 compileFile
) where
			
import Compiler.Module (Module)
      

-- | CManager class provides a 'compile' method, for string to symbol-code modules.
class CManager a b where
    -- | Compiles a string to a module.
    compile :: String -> Module a b  


-- | Helper function to compile from a given file.
compileFile :: CManager a b => 
	       String                -- ^ Filename
	    -> IO (Module a b)       
-- FIXME: should check for errors.
compileFile file = 
    do text <- readFile file
       return $ compile text
       
