-----------------------------------------------------------------
-- |
-- Module      : Shell.Compiler
-- Copyright   : (c) Babel Group 2004
-- License     : GPL
--
-- Maintainer  : egallego@babel.ls.fi.upm.es
-- Stability   : very experimental
-- Portability : portable
-- Last modified: 
--
-- Some utilities for compilation management.
-- 
-----------------------------------------------------------------
module Shell.Compiler (
		       compileToProlog,
		       compileToRelational,
		       compileToRalog
) where

import AST.Ralog
import AST.Prolog
import AST.Relational

import Compiler.Module

import Translator
import Translator.String.Prolog
import Translator.Relational.Ralog
import Translator.Prolog.Relational

--

compileToProlog :: String -> TransResult Predicate Clause
compileToProlog s = translate s

compileToRelational :: Module Predicate Clause -> TransResult Predicate Relational
compileToRelational pm = translate pm

compileToRalog :: Module Predicate Relational -> TransResult Predicate Ralog
compileToRalog rm = translate rm
