{

-- This module parses the interactive shell commands.

module Shell.Interactive.Parser where

import Shell.Interactive.Lexer
import Shell.Interactive.Command

}

%name interactive_parser

%tokentype { InteractiveToken }

-- %monad { PrologParseMonad }

-- Tokens of Interactive command line.
%token
      ':'             { TSym ":"   }
      NL              { TNewLine   }
      STRING          { TString $$ } 

%%


cmdline :: { Command }
    : shellcmd                 { ShellCommand $1 }
    | query                    { Query $1        }
    |                          { Empty           }

shellcmd :: { InternalC }
    : ':' shellcmd2            { $2              } 

shellcmd2 :: { InternalC }
    : STRING args              {
				  case parseCommand $1 $2 of
				       Just c  -> c
				       Nothing -> error "Unknown command"				     
			       }

args :: { [String] }
    :                          { [] }
    | STRING args              { $1:$2 }

query :: { String }
    : STRING                     { $1 }

{

-- BIG FIXME PLEASE!!!
happyError _ = error "Parse error in command parser"


}
