-----------------------------------------------------------------
-- |
-- Module      : Translator.Translator
-- Copyright   : (c) Babel Group 2004
-- License     : GPL
--
-- Maintainer  : egallego@babel.ls.fi.upm.es
-- Stability   : very experimental
-- Portability : portable
-- Last modified: 20 Oct 2004, 16:31
--
-- Some utilities for compilation management.
-- 
-----------------------------------------------------------------

module Translator 
where

import Data.Either

import Compiler.Module (Module)

-- | 
type TransError = [Char]

type TransResult k c = Either TransError (Module k c)

-- | Translator class is intended for no step by step translations,
--   such as lexers, parsers or language transformers.
--
--   For a class modelling an execution, see Engine.Rewritable

class Translator s k c where
    translate :: s -> TransResult k c

-- | Helper function to compile from a given file.
translateFile :: Translator String a b => 
		 String                -- ^ Filename
	      -> IO (TransResult a b)

-- FIXME: should check for errors.
translateFile file = 
    do text <- readFile file
       return $ translate text

